
#ifdef USE_QML
# include <QGuiApplication>
# include <QQmlApplicationEngine>
#else
# include "mainwindow.h"
#endif
# include <QApplication>

#include <QDirIterator>

#include "SigMFParser.h"

using namespace Qt::StringLiterals;

#ifdef USE_QML
QGuiApplication* g_app = nullptr;
QQmlApplicationEngine* g_engine = nullptr;
#else
QApplication* g_app = nullptr;
#endif

int main(int argc, char *argv[])
{
//#ifdef USE_QML
#if 0
    g_app = new QGuiApplication(argc, argv);
#else
    g_app = new QApplication(argc, argv);
#endif
    /*QDirIterator it(":", QDirIterator::Subdirectories);
    while (it.hasNext()) {
        qInfo() << it.next();
    }*/

#ifdef USE_QML
    g_engine = new QQmlApplicationEngine;
    QObject::connect(g_engine, &QQmlApplicationEngine::objectCreationFailed, g_app,
        []() { QCoreApplication::exit(-1);
               qInfo() << "objectCreationFailed";
             }, Qt::QueuedConnection);
    qmlRegisterSingletonType<SigMFParser>("SigMFPreviewSings", 1, 0, "FileParser",
        [](QQmlEngine *engine, QJSEngine *scriptEngine) -> QObject * {
            Q_UNUSED(engine)
            Q_UNUSED(scriptEngine)

            SigMFParser *parser = new SigMFParser();
            return parser;
        });

    //SigMFParser* parser = g_engine->singletonInstance<SigMFParser*>("SigMFPreviewSings", "FileParser");

    g_engine->loadFromModule("sigmf_preview_qml", "Main");
#else
    MainWindow w;
    SigMFParser parser;
    //parser.browseForFile();
    QObject::connect(&w, &MainWindow::browseButton,
                     &parser, &SigMFParser::browseForFile);
    w.show();
#endif

#ifdef Q_OS_WASM
    return 0;
#else
    return g_app->exec();
#endif
}
