#include "mainwindow.h"
#include "./ui_mainwindow.h"

#include <QTimer>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    connect(ui->pushButton, &QPushButton::clicked,
            this, &MainWindow::browseButton);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::setModel(QAbstractItemModel *mod)
{
    m_model = mod;
    ui->treeView->setModel(m_model);
    connect(m_model, &QAbstractItemModel::modelReset,
            this,    &MainWindow::modelWasUpdated);
          //this, [this]() { QTimer::singleShot(100, this, &MainWindow::modelWasUpdated); });
}

void MainWindow::modelWasUpdated()
{
    ui->treeView->expandRecursively({}, 2);
    for (int c = 0; c < m_model->columnCount(); ++c) {
        ui->treeView->resizeColumnToContents(c);
    }
}
